BuildRequires: maven-scm
BuildRequires: /proc
BuildRequires: jpackage-1.4-compat
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}


Name:           ws-commons-axiom
Version:        1.2.4
Release:        alt1_1jpp1.7
Epoch:          0
Summary:        AXIOM XML infoset model for Apache Axis2.
License:        Apache Software License 2.0
Url:            http://ws.apache.org/commons/axiom/
Group:          Development/Java
Source0:        %{name}-%{version}.tar.gz
##svn export http://svn.apache.org/repos/asf/webservices/commons/tags/axiom/1_2_4 ws-commons-axiom-1.2.4


Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-build.xml
Source4:        %{name}-modules-axiom-api-build.xml
Source5:        %{name}-modules-axiom-dom-build.xml
Source6:        %{name}-modules-axiom-impl-build.xml


Patch0:         %{name}-pom_xml.patch
Patch1:         %{name}-modules-axiom-api-pom_xml.patch
Patch2:         %{name}-modules-axiom-tests-pom_xml.patch
Patch3:         %{name}-site_xml.patch



BuildRequires: jpackage-utils >= 0:1.7.2
BuildRequires: ant >= 0:1.6
BuildRequires: junit >= 0:3.8.2
%if %{with_maven}
BuildRequires: maven2-plugins >= 2.0.4-10jpp
BuildRequires: mojo-maven2-plugin-jdepend
BuildRequires: maven2-plugin-assembly
BuildRequires: maven2-plugin-compiler
BuildRequires: maven2-plugin-install
BuildRequires: maven2-plugin-javadoc
BuildRequires: maven2-plugin-jar
BuildRequires: maven2-plugin-one
BuildRequires: maven2-plugin-project-info-reports
BuildRequires: maven2-plugin-release
BuildRequires: maven2-plugin-resources
BuildRequires: maven2-plugin-site
BuildRequires: maven2-plugin-source
BuildRequires: maven2-plugin-surefire
BuildRequires: maven2-default-skin
%endif
Requires(post): jpackage-utils >= 0:1.7.2
Requires(postun): jpackage-utils >= 0:1.7.2
%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif

BuildRequires: bea-stax-api
BuildRequires: sun-mail >= 0:1.4
BuildRequires: sun-jaf >= 0:1.1
BuildRequires: jakarta-commons-logging
BuildRequires: jaxen
BuildRequires: jdepend
BuildRequires: wstx >= 0:3.2.1
BuildRequires: xerces-j2
BuildRequires: xml-commons-jaxp-1.3-apis
BuildRequires: xmlunit

Requires: bea-stax-api
Requires: xml-commons-jaxp-1.3-apis
Requires: javamail = 0:1.4
Requires: jaf = 0:1.1
Requires: jakarta-commons-logging
Requires: jaxen
Requires: wstx >= 0:3.2.1
Requires: xerces-j2
Obsoletes: apache-axiom = 0:1.0
Provides:  apache-axiom = %{epoch}:%{version}-%{release}
%if ! %{gcj_support}
BuildArch:      noarch
%endif


%description
AXIOM stands for AXis Object Model (also known as OM - Object Model)
and refers to the XML infoset model that is initialy developed for
Apache Axis2.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Obsoletes:      apache-axiom-javadoc = 0:1.0
Provides:       apache-axiom-javadoc = %{epoch}:%{version}-%{release}

%description javadoc
%{summary}.

%if %{with_maven}
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.
%endif

%prep
%setup -q
cp %{SOURCE1} settings.xml

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav

rm -f src/site/xdoc/download.*
cp %{SOURCE3}  build.xml
cp %{SOURCE4}  modules/axiom-api/build.xml
cp %{SOURCE5}  modules/axiom-dom/build.xml
cp %{SOURCE6}  modules/axiom-impl/build.xml

mkdir modules/axiom-api/src/site
cp src/site/site.xml modules/axiom-api/src/site
mkdir modules/axiom-dom/src/site
cp src/site/site.xml modules/axiom-dom/src/site
mkdir modules/axiom-impl/src/site
cp src/site/site.xml modules/axiom-impl/src/site


%build
mkdir external_repo
ln -s %{_javadir} external_repo/JPP


%if %{with_maven}
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

export MAVEN_SETTINGS=$(pwd)/settings.xml


mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven2.jpp.mode=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install javadoc:javadoc site

pushd modules/axiom-tests
    mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven2.jpp.mode=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install
popd

%else
export CLASSPATH=$(build-classpath \
commons-logging \
jaxen \
sun-mail-monolithic \
sun-jaf \
xml-commons-jaxp-1.3-apis \
bea-stax-api \
)
pushd modules/axiom-api
ant -Dbuild.sysclasspath=only jar test javadoc
popd
CLASSPATH=$CLASSPATH:$(pwd)/modules/axiom-api/target/axiom-api-%{version}.jar
pushd modules/axiom-impl
ant -Dbuild.sysclasspath=only jar test javadoc
popd
CLASSPATH=$CLASSPATH:$(pwd)/modules/axiom-impl/target/axiom-impl-%{version}.jar
pushd modules/axiom-dom
ant -Dbuild.sysclasspath=only jar test javadoc
popd

# Yes, create target
mkdir target
%endif

mkdir tmp
pushd tmp
jar xf ../modules/axiom-impl/target/axiom-impl-%{version}.jar
jar xf ../modules/axiom-dom/target/axiom-dom-%{version}.jar
jar xf ../modules/axiom-api/target/axiom-api-%{version}.jar
jar cf ../target/axiom-%{version}.jar *
popd
rm -rf tmp


%install
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

install -m 644 target/axiom-%{version}.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 modules/axiom-api/target/axiom-api-%{version}.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-api-%{version}.jar
install -m 644 modules/axiom-impl/target/axiom-impl-%{version}.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-impl-%{version}.jar
install -m 644 modules/axiom-dom/target/axiom-dom-%{version}.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-dom-%{version}.jar
%add_to_maven_depmap org.apache.ws.commons.axiom axiom %{version} JPP %{name}
%add_to_maven_depmap org.apache.ws.commons.axiom axiom-api %{version} JPP %{name}-api
%add_to_maven_depmap org.apache.ws.commons.axiom axiom-dom %{version} JPP %{name}-dom
%add_to_maven_depmap org.apache.ws.commons.axiom axiom-impl %{version} JPP %{name}-impl
# create unprefixed and unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}
for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done
)

# poms
%if %{with_maven}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom
install -pm 644 modules/axiom-api/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-api.pom
install -pm 644 modules/axiom-dom/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dom.pom
install -pm 644 modules/axiom-impl/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-impl.pom
%endif

# javadocs
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/api
cp -pr modules/axiom-api/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/api
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/dom
cp -pr modules/axiom-dom/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/dom
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/impl
cp -pr modules/axiom-impl/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/impl
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp *.txt $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
%if %{with_maven}
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%endif

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%doc %{_datadir}/%{name}-%{version}
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-api-%{version}.jar
%{_javadir}/%{name}-api.jar
%{_javadir}/%{name}-dom-%{version}.jar
%{_javadir}/%{name}-dom.jar
%{_javadir}/%{name}-impl-%{version}.jar
%{_javadir}/%{name}-impl.jar
%if %{with_maven}
%{_datadir}/maven2/poms/*
%endif
%{_mavendepmapfragdir}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%if %{with_maven}
%files manual
%{_docdir}/%{name}-%{version}
%endif

%changelog
* Wed Nov 28 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.2.4-alt1_1jpp1.7
- converted from JPackage by jppimport script

